/*****************************************************************************
*                                                                            *
*   Home Finance Database System.                                            *
*   Keep track of your money and have easy access to finding data.           *
*                                                                            *
*   Originally developed on Linux                                            *
*                                                                            *
*   Author: Peter Leif Rasmussen, 1997                                       *
*****************************************************************************/

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<time.h>
#include"finance.h"

extern rec_unit *finance, *finance_end;

extern void time_check(struct tm *tid);
extern void display_data(rec_unit *,rec_unit *,int);

rec_unit *get_date(rec_unit *, int [][], rec_unit *, int *);
void sort_dates(rec_unit **, int, rec_unit *);
int convert_date(rec_unit *);

void search_date(void)
{
int return_number,did_copy;
int start_date_year,start_date_month,start_date_day;
int end_date_year,end_date_month,end_date_day;
int dates[2][3];
rec_unit *temp_point, *return_point, *start_point, *end_point;
char temp[1000];
struct tm tid;

temp_point=finance;

time_check(&tid);
fgets(temp,1000,stdin);

printf("\nStart date:\n");fflush(stdout);
printf("\tPlease enter the year [%d]: ",tid.tm_year);
fgets(temp,1000,stdin);
if(strlen(temp)==1) start_date_year=tid.tm_year;
else start_date_year=atoi(temp);

printf("\tPlease enter the month [%d]: ",tid.tm_mon+1);
fgets(temp,1000,stdin);
if(strlen(temp)==1) start_date_month=tid.tm_mon+1;
else start_date_month=atoi(temp);

printf("\tPlease enter the day [1]: ");
fgets(temp,1000,stdin);
if(strlen(temp)==1) start_date_day=1;
else start_date_day=atoi(temp);

dates[0][0]=start_date_year;
dates[0][1]=start_date_month;
dates[0][2]=start_date_day;

printf("\nEnd date:\n");fflush(stdout);

printf("\tPlease enter the year [%d]: ",tid.tm_year);
fgets(temp,1000,stdin);
if(strlen(temp)==1) end_date_year=tid.tm_year;
else end_date_year=atoi(temp);

printf("\tPlease enter the month [%d]: ",tid.tm_mon+1);
fgets(temp,1000,stdin);
if(strlen(temp)==1) end_date_month=tid.tm_mon+1;
else end_date_month=atoi(temp);

printf("\tPlease enter the day [31]: ");
fgets(temp,1000,stdin);
if(strlen(temp)==1) end_date_day=31;
else end_date_day=atoi(temp);

dates[1][0]=end_date_year;
dates[1][1]=end_date_month;
dates[1][2]=end_date_day;

return_number=0;
return_point=start_point=(rec_unit *)malloc(sizeof(rec_unit));

do 	{
	return_point->description=(char *)malloc(100);

	temp_point=get_date(return_point,dates,temp_point,&did_copy); 
	end_point=return_point;
	return_point->next_rec=(rec_unit *)malloc(sizeof(rec_unit));
	return_point=return_point->next_rec;
	if(did_copy==1) return_number++;
	} while(temp_point!=finance_end);

display_data(start_point,end_point,return_number);
}

int check_date(int dates[2][3], rec_unit *bookmark)
{
char s_year_s[10],s_month_s[5],s_day_s[5];
char e_year_s[10],e_month_s[5],e_day_s[5];
char year[10],month[5],day[5];
int date,start_date,end_date;

sprintf(year,"%d",bookmark->year);

if(bookmark->month<10) sprintf(month,"0%d",bookmark->month);
else sprintf(month,"%d",bookmark->month);
strcat(year,month);

if(bookmark->day<10) sprintf(day,"0%d",bookmark->day);
else sprintf(day,"%d",bookmark->day);
strcat(year,day);
date=atoi(year);

sprintf(s_year_s,"%d",dates[0][0]);

if(dates[0][1]<10) sprintf(s_month_s,"0%d",dates[0][1]);
else sprintf(s_month_s,"%d",dates[0][1]);
strcat(s_year_s,s_month_s);

if(dates[0][2]<10) sprintf(s_day_s,"0%d",dates[0][2]);
else sprintf(s_day_s,"%d",dates[0][2]);
strcat(s_year_s,s_day_s);

start_date=atoi(s_year_s);

sprintf(e_year_s,"%d",dates[1][0]);

if(dates[1][1]<10) sprintf(e_month_s,"0%d",dates[1][1]);
else sprintf(e_month_s,"%d",dates[1][1]);
strcat(e_year_s,e_month_s);

if(dates[1][2]<10) sprintf(e_day_s,"0%d",dates[1][2]);
else sprintf(e_day_s,"%d",dates[1][2]);
strcat(e_year_s,e_day_s);

end_date=atoi(e_year_s);

if(start_date<=date && date<end_date) return 0;

return 1;
}

rec_unit *get_date(rec_unit *choose, int dates[2][3], rec_unit *bookmark, int *did_copy)
{
*did_copy=0;

while((bookmark->next_rec!=finance_end) && check_date(dates,bookmark))
  bookmark=bookmark->next_rec;

if(!check_date(dates,bookmark))
  {
  choose->ID=bookmark->ID;
  strcpy(choose->description,bookmark->description);
  choose->income=bookmark->income;
  choose->cash=bookmark->cash;
  choose->credit=bookmark->credit;
  choose->year=bookmark->year;
  choose->month=bookmark->month;
  choose->day=bookmark->day;
  *did_copy=1;
  }

return bookmark->next_rec;
}

void sort_dates(rec_unit **return_list, int return_number, rec_unit *end_point)
{
rec_unit *temp_start_point,*temp_point;
rec_unit *seq[100], *prev_point,*tmp_point;
int n,m,new_val,taken=1;
int temp_start_val,temp_val;

temp_start_point=prev_point=*return_list;
temp_start_val=temp_start_val=convert_date(temp_start_point);

for(m=0;m<return_number;m++)
	{
	temp_val=temp_start_val;
	tmp_point=temp_point=temp_start_point;

	for(n=0;n<return_number-taken;n++)
		{
		new_val=convert_date(tmp_point->next_rec);
		if(new_val<temp_val)
			{
			temp_val=new_val;
			prev_point=tmp_point;
			temp_point=tmp_point->next_rec;
			tmp_point=tmp_point->next_rec;
			}
		else tmp_point=tmp_point->next_rec;
		}
	seq[m]=temp_point;
	if(m>0) seq[m-1]->next_rec=seq[m];
	taken++;
	if(temp_point==temp_start_point)
		{
		temp_start_val=convert_date(temp_start_point->next_rec);
		temp_start_point=temp_start_point->next_rec;
		prev_point=temp_start_point;
		}
	else 	if(temp_point==end_point) end_point=prev_point;
		else 	prev_point->next_rec=temp_point->next_rec;
	}
*return_list=seq[0];
}

int convert_date(rec_unit *incoming)
{
char year[20],month[10],day[10];
int date;

sprintf(year,"%d",incoming->year);

if(0<incoming->month && incoming->month<10) sprintf(month,"0%d",incoming->month);
else {	if(incoming->month<100) sprintf(month,"%d",incoming->month);
	else return -1;}
strcat(year,month);

if(0<incoming->day && incoming->day<10) sprintf(day,"0%d",incoming->day);
else {	if(incoming->day<100) sprintf(day,"%d",incoming->day);
	else return -1;}
strcat(year,day);

date=atoi(year);

return date;
}
